library(ipeglim)
rm(list=ls())

source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/cpef2reg.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/cpef.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/summary.imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/update.imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/print.summary.imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/plot.summary.imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/pbox.summary.imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/iprior.R")

y <- rvg4yx(N=5e1, pars=1, ztrunc=TRUE, xreg=FALSE, kind="pois")$y
table(y)

m2fit <- model(formula=y~0, ztrunc=TRUE, dist="pois")
lc0 <- list(lhs=rbind(c(1,0), c(-1,0), c(0,1), c(0,-1)), rhs=c(0.05, -10, 0.05, -10))
cmfit <- impose(obj=m2fit, eqns=lc0)

oaq1 <- update(obj=cmfit, method="AQ", apriori="lgamma")
saq1 <- summary(oaq1)

ola1 <- update(obj=cmfit, method="LA", apriori="lgamma")
sla1 <- summary(ola1)

omh1 <- update(obj=cmfit, method="MH", apriori="lgamma")
smh1 <- summary(sla1)

ois1 <- update(obj=cmfit, method="IS", apriori="lgamma")
sis1 <- summary(ois1)


oaq2 <- update(obj=cmfit, method="AQ", apriori="normal")
saq2 <- summary(oaq2)

ola2 <- update(obj=cmfit, method="LA", apriori="normal")
sla2 <- summary(ola2)

omh2 <- update(obj=cmfit, method="MH", apriori="normal")
smh2 <- summary(smh2)

ois2 <- update(obj=cmfit, method="IS", apriori="normal")
sis2 <- summary(sis2)
