# ipeglim/demo/rvg-mvbin.R
# 
# Generation of multivariate bernoulli variates
# 2013.10.15 - final test 

library(ipeglim)

# case 1. 
# MBV(mu, sigma)
rm(list=ls())
pars <- c(1,-1)
xm <- c(0.3, 0.5)
xr <- diag(2)
xr[2] <- xr[3] <- r <- 0

tmp <- rvg4yx(N=1e3, Xreg=TRUE, ztrunc=TRUE, kind="mvbin", pars=pars, margprob=xm, bincorr=xr, center.X=FALSE)
dat <- tmp$yX

dat <- tmp$yX
X <- tmp$X
head(X)
colMeans(X)
cov(X)
cor(X)
 
fit <- summary(ztpr(formula=y~x1+x2-1, data=dat, dist="poisson", ztrunc=TRUE))
fit


# case 2. 
# MBV(mu, sigma)
rm(list=ls())
pars <- c(-1)
xm <- c(0.5)

tmp <- rvg4yx(N=1e3, Xreg=TRUE, ztrunc=TRUE, kind="mvbin", cf0=-1, pars=pars, size=1, prob=0.3, center.X=FALSE)
dat <- tmp$yX

dat <- tmp$yX
X <- tmp$X
head(X)
colMeans(X)
cov(X)
cor(X)
 
fit <- summary(ztpr(formula=y~x1, data=dat, dist="poisson", ztrunc=TRUE))
fit
