## ipeglim/demo/xreg-sphere3d-nox0.R
## 
## y ~ b1x1 + b2x2 + b3x3 (no intercept model)

library(ipeglim)
rm(list=ls())

source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/cpef2reg.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/cpef.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/model.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/iprior.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/update_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/summary_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/print_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/plot_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/plot_summary.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/pbox_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/qc.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/rvg4yx.R")

# structure of X
xm <- c(-3,2,1)
xsd <- sqrt(c(1,1,1))
xr <- diag(3)
xr[1,2] <- xr[2,1] <- r1 <- 0
xr[1,3] <- xr[3,1] <- r2 <- r1
xr[2,3] <- xr[3,2] <- r3 <- r1
xsigma <- t(diag(xsd))%*%xr%*%diag(xsd)

# structure of B
bm <- c(0,0,0)
bsd <- c(1,1,1)
br <- diag(3)
br[1,2] <- br[2,1] <- r1 <- 0
br[1,3] <- br[3,1] <- r2 <- r1
br[2,3] <- br[3,2] <- r3 <- r1
Bmat <- t(diag(bsd))%*%br%*%diag(bsd)
Bmat <- Bmat*0.01

# no intercept model
tmp <- rvg4yx(N=1e2, pars=c(0.5, 0.5, -0.5), ztrunc=TRUE, xreg=TRUE, kind="mvnorm", mean=xm, sigma=xsigma, center.X=TRUE) ## FALSE??
dat <- tmp$yX
print(table(dat$y))

m2fit <- model(formula=y~x1+x2+x3-1, data=dat, ztrunc=TRUE, dist="poisson")
cmfit <- iprior(obj=m2fit, circle=list(x0=0, y0=0, z0=0, r=1, len=20))
plot(cmfit, # for m0xtms
  main="Sphere Type of Imprecise Prior Specification", 
  sub=list(expression(radius==0.5~"at"~"("~beta[1]==0~","~beta[2]==0~","~beta[3]==0~")"), cex=1.25),
  xlab=expression(beta[1]),
  ylab=expression(beta[2]),
  zlab=expression(beta[3]), col="darkblue")

# note:
# do not run 'setGrid(obj, len)' with the constraints of 'm0shape=sphere3d'

# op <- update(obj=cmfit, method="LAF", B=Bmat, control=list(flip=TRUE), aprior="normal")
op <- update(obj=cmfit, method="LA", B=Bmat, aprior="normal", silent=FALSE, control=list(qc=TRUE))
sop <- summary(op)

# http://procomun.wordpress.com/2011/03/18/splomr/
# how to identify outliers for quality control?

plot(sop, main="Shrinkage on Imprecise Priors")

# another visualization
if(FALSE){
# save(sop, file="3dsop.RData")
# 28, 29, 130, 129, 99

est <- sop$est
plot(est, col="darkblue")

trellis.focus()
panel.link.splom(verbose=TRUE)
trellis.unfocus()


x <- sop
est <- as.data.frame(x$est)
tobj <- splom(est, type="p", pch=19, cex=0.5, col="darkblue")
cloud(x3~x1*x2, data=est)
}

if(FALSE){
BETAs <- pbox(x=sop, which.beta=1)
BB <- extractMCHAIN(BETAs)
pbox(x=BB, which.beta=2)
pbox(x=BB, which.beta=3)
}
# contour plot + wireframe (Is this neccessary?)
# problematic with sphere3d
# cwplot(sop) 

