## ipeglim/inst/thesis/fig/o3ef.R
## 
## 2013.11.13
## o3ef = order 3 exponential family of distribution (i.e., normal prior)

library(ipeglim)
rm(list=ls())

lmu <- c(-3, 2, 1, 0, -1, -2, 3)
e0 <- seq(0,2,0.25)
e2 <- seq(0,3,0.2)
hcube <- expand.grid(e0=e0, e2=e2, lmu=lmu)

e1 <- apply(hcube, 1, function(x){
  x <- as.vector(x)
  rt.e1 <- tryCatch(uniroot(eta1fn, lower=-20, upper=30, tol=1e-4, eta0=x[1], eta2=x[2], logm=x[3])$root, error=function(e) return(NaN))
  return(rt.e1)
  })
hcube$e1 <- e1
z <- range(e1, na.rm=TRUE)

save(list=ls(), file="~/Documents/PhD/ipeglim/thesis/fig/o3ef_levelset.RData")
