## ipeglim/inst/thesis/fig/o3ef_surface.R
## Normal imprecise prior on the use of models without covariates
## 2013.11.13

rm(list=ls())
library(ipeglim)
set.seed(16979238)
options(warn=2)


source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/cpef.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/model.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/iprior.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/update_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/summary_imprecise.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/xtms2eqns.R")
source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/plot_imprecise.R")


par(mfrow=c(2,2), mar=c(4,4,0,0))

y0 <- rvg4yx(N=100, pars=2, ztrunc=FALSE, xreg=FALSE, kind="pois")$y
# table(y)
# > y
# [1] 2 1 2 0 1 3 2 1 3 1

## imprecise prior specification
## eqn1. -6 <= nu <= 6
## eqn2. 0.5 <= tau^2 <= 2.5
# lc0 <- list(lhs=rbind(c(1,0), c(-1,0), c(0,1), c(0,-1)), rhs=c(-3, -3, 0.5, -2.5))

# characterization on (xi_1, xi_2)
# lc0 <- list(lhs=rbind(c(1,0), c(-1,0), c(0,1), c(0,-1)), rhs=c(-1, -1, 0.5, -1))
lc0 <- list(lhs=rbind(c(1,0), c(-1,0), c(0,1), c(0,-1)), rhs=c(-1, -1, 0.1, -1))

y <- y0[1]
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson")
cmfit <- iprior(obj=m2fit, eqns=lc0)
cmfit <- set.grid(obj=cmfit, len=15)
op <- update(obj=cmfit, method="LA", apriori="normal", silent=TRUE)
sop <- summary(op, silent=TRUE)

## visualization - imprecise posterior
z <- range(sop$est)
mar <- 0.2
plot(sop, xlim=c(-1.2,1.2), ylim=c(0, 1.2), zlim=c(z[1]-mar, z[2]+mar), 
		 xlab=list(expression(xi[1])), 
		 ylab=list(expression(xi[2])), 
		 zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90),
		 main=expression(n==1),
		 split=c(1,1,2,2), more=TRUE)

## n=2

y <- y0[1:2]
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson")
cmfit <- iprior(obj=m2fit, eqns=lc0)
cmfit <- set.grid(obj=cmfit, len=15)
op <- update(obj=cmfit, method="LA", apriori="normal", silent=TRUE)
sop <- summary(op, silent=TRUE)

## visualization - imprecise posterior
plot(sop, xlim=c(-1.2,1.2), ylim=c(0, 1.2), zlim=c(z[1]-mar, z[2]+mar), 
		 xlab=list(expression(xi[1])), 
		 ylab=list(expression(xi[2])), 
		 zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90),
		 main=expression(n==2),
		 split=c(2,1,2,2), more=TRUE)


## n = 5

y <- y0[1:5]
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson")
cmfit <- iprior(obj=m2fit, eqns=lc0)
cmfit <- set.grid(obj=cmfit, len=15)
op <- update(obj=cmfit, method="LA", apriori="normal", silent=TRUE)
sop <- summary(op, silent=TRUE)

## visualization - imprecise posterior
plot(sop, xlim=c(-1.2,1.2), ylim=c(0, 1.2), zlim=c(z[1]-mar, z[2]+mar), 
		 xlab=list(expression(xi[1])), 
		 ylab=list(expression(xi[2])), 
		 zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90),
		 main=expression(n==5),
		 split=c(1,2,2,2), more=TRUE)



## n = 10

y <- y0[1:10]
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson")
cmfit <- iprior(obj=m2fit, eqns=lc0)
cmfit <- set.grid(obj=cmfit, len=15)
op <- update(obj=cmfit, method="LA", apriori="normal", silent=TRUE)
sop <- summary(op, silent=TRUE)

## visualization - imprecise posterior
plot(sop, xlim=c(-1.2,1.2), ylim=c(0, 1.2), zlim=c(z[1]-mar, z[2]+mar), 
		 xlab=list(expression(nu)), 
		 ylab=list(expression(tau^2)), 
		 zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90),
		 main=expression(n==10),
		 split=c(2,2,2,2), more=TRUE)

