\name{plot.imprecise}
\alias{plot,}
\alias{plot.imprecise}
\alias{plot.imprecise,}
\alias{plot.summary.imprecise}
\title{Object Visualization in Imprecise Inferential Framework}
\usage{
  \method{plot}{imprecise} (x, ...)

  \method{plot}{summary.imprecise} (x, ...)
}
\arguments{
  \item{x}{an object of class of \code{imprecise} or
  \code{imprecise.summary}.}

  \item{...}{other passing arguments to \code{print}}
}
\description{
  \code{plot} use xy-coordinate information produced from
  \code{\link{iprior}} for an imprecise prior and the
  information produced from \code{\link{update}} for an
  imprecise posterior.
}
\details{
  Visualization of Imprecise Prior and Posterior \itemize{

  \item{circle2d}{if xreg=TRUE, it is suggested to draw a
  polygon or scatter plot in 2 dimensional space. If
  xreg=FALSE, there is no available visiualization method;
  then, use a perspective plot (or level plots) with
  contours.}

  \item{circle3d}{if xreg=TRUE, it is suggested to draw a
  3-dimensional scatter plot. If xreg=FALSE, no methods
  since a number of hyperparameters is limited to 2 not 3.}

  \item{eqns2d}{if xreg=TRUE, it would be good to draw a
  two-dimensional polygon or scatter plot. If xreg=FALSE,
  there is no available visualization method; then, use a
  perspective plot (or level plots) with contours. }

  \item{eqns3d}{if xreg=TRUE, it would be good to generate
  a three-dimensional scatter plot. If xreg=FALSE, no
  methods since a number of hyperparameters is limited to 2
  not 3.}

  \item{others}{if a number of dimensions is more than 4,
  there is no particular visualization metho since one more
  additional dimension is required to present a magnitude
  of imprecision. In this case, it would be good to
  generate a pairwise plot with contours.} }
}
\note{
  The function \code{inout} in the package \code{mgcv} is
  used.
}
\author{
  Chel Hee Lee <\email{gnustats@gmail.com}>
}
\seealso{
  \code{\link{in.out}}, \code{\link{chull}},
  \code{\link{panel.3dwire}}
}
\keyword{circle,}
\keyword{convex,}
\keyword{polygon,}
\keyword{polyhedren,}
\keyword{sphere}

