\name{simulateYX2}
\alias{simulateYX2}
\title{Generating Random Variates for Simulation Studies with Mulitiple Sources}
\usage{
  simulateYX2(N, Ystr = list(ymean, ysigma), param1,
    param2,
    Xstr = list(type = c("mvnorm", "mvbion", "mixed", "multinomial"), Xmean, XR, Xsd, Xmat = NULL),
    shape = NULL, ztrunc, xreg, seed = NULL, ...)
}
\arguments{
  \item{N}{a number of random variates}

  \item{Xstr}{a structure of covariates X}

  \item{ztrunc}{FALSE by default}

  \item{xreg}{FALSE by default}

  \item{seed}{NULL a random seed}

  \item{shape}{a shape parameter of gamma distribution}

  \item{...}{other arguments}

  \item{Ystr}{structure of responses}

  \item{param1}{a vector of regression parameters 1}

  \item{param2}{a vector of regression parameters 2}
}
\value{
  a list with components \item{n}{the number of
  observations which are actually realized} \item{y}{the
  \code{n}-by-\code{1} vector of response generated}
  \item{X}{the \code{n}-by-\code{p-1} matrix (an intercept
  is excluded)} \item{yX}{the \code{n}-by-\code{p} data
  frame which includes \code{y} and \code{X}}
}
\description{
  \code{simulateYX2} generates random variates of a
  response variable under the given conditions of mean and
  variance-covariance structure of matrices of predictors
  and their coefficients.
}
\details{
  The mean parameter of a response variable is a function
  of linear predictor by a link function in the context of
  generalized linear models.

  Log and logit links are supported.

  Default to \code{Xstr} is an independent multivariate
  normal distribution with mean \code{Xmean}, correlation
  \code{R}, and standard deviation \code{Xsd}.
}
\note{
  Default to a matrix decomposition \code{method} is
  \code{eigen}. Other options are \code{chol} and
  \code{svd}.

  Currently, the link \code{logit} is not supported.
}
\section{TODO}{
  \itemize{ \item A component with coefficients of
  predictors is not implemented yet. \item Multinomal type
  of predictor is not incorporated yet. }
}

\section{FIXME}{
  \itemize{ \item No bugs are reported yet. }
}
\examples{
# do not run
}
\author{
  Chel Hee Lee <\email{gnustats@gmail.com}>
}
\seealso{
  \code{\link{rmvnorm}}
}

