\name{summary.a90logit}
\alias{print.summary.a90logit}
\alias{summary.a90logit}
\title{Object summaries of logistic regression model for capture-recaputre
data and its display}
\usage{
  \method{summary}{a90logit} (object, alpha = 0.05, k = 2,
    ...)
}
\arguments{
  \item{object}{a fitted model object,}

  \item{alpha}{a confidence level required
  (\code{alpha=0.05} by default),}

  \item{k}{an integer, the penalty per parameter to be
  used; the \code{k=2} is used for classical AIC (Akaike's
  information criteria),}

  \item{...}{other arguments}
}
\value{
  An object of class \code{summary.a90logit} with
  components including \item{tab}{Formatted object to be
  printed including coefficients, standard errors, etc.
  Significance star is also printed with stars,}
  \item{aic}{Akaike Information Criteria,}
  \item{N}{Estimate of unknown population size,}
  \item{VarN}{Variance of \code{N},} \item{ciu}{Upper bound
  of confidence interval,} \item{cil}{Lower bound of
  confidence interval.}
}
\description{
  \code{summary} is a generic function for summarizing
  results produced from logistic regression model with
  maximum likelihood estimation. Using the estimates of
  fitted object \code{obj}, the size of unknown population
  \code{N} and its \code{100*(1-alpha)} confidence interval
  are calculated.
}
\note{
  \code{print.summary.a90logit} is a generic function that
  displays all summaries of object generated from
  \code{summary.a90logit}.
}
\author{
  Chel Hee Lee <gnustats@gmail.com>
}
\seealso{
  \code{\link{AIC}}, \code{\link{extractAIC}},
  \code{\link{printCoefmat}}
}

